/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
package jdct;

import jdct.*;
import dbStatic.* ;
import java.lang.* ;
import java.awt.*;
import java.awt.event.*;

class JdctMenuFieldInstance extends Choice implements ItemListener
{
	private JdctFrame frame;
	private JdctInstanceGui recordGui;

	private String recordName;
	private String fieldName;

	JdctMenuFieldInstance(JdctFrame frame, JdctInstanceGui recordGui,
	    String recordName, String fieldName,String[] menu,String selection)
	    {
		super();
		for (int i=0; i<menu.length; i++) {
			this.add(menu[i]);
		}
		this.select(selection);
		addItemListener(this);

		this.frame = frame;
		this.recordGui = recordGui;
		this.recordName = recordName;
		this.fieldName = fieldName;
	}

	public void itemStateChanged(ItemEvent e) {

		Component c = (Component)e.getSource();
		Point p = c.getLocationOnScreen();
		Dimension d = c.getSize();
		//Point location = new Point(p.x - 200, p.y + d.height);
		Point location   = new Point(p.x - 200, p.y );

		DbBase dbBase = frame.getDbBase();
		DbEntry dbEntry = new DbEntry(dbBase);
		if(!dbEntry.findRecord(recordName)) {
			recordGui.messageDialog("Error",
			    "Record " + recordName + " Not Found?",location);
			dbEntry.free();
			return;
		}
		if(!dbEntry.findField(fieldName)) {
			recordGui.messageDialog("Error",
			    "Field " + fieldName + " Not Found?",location);
			dbEntry.free();
			return;
		}
		Choice menu = ((Choice)e.getSource());
		String newValue = menu.getSelectedItem();
		String oldValue = dbEntry.getString();

		if(oldValue==null) oldValue = " ";
		if(newValue.equals(oldValue)) return;

		dbEntry.putString(newValue);
		menu.select(dbEntry.getString());

		dbEntry.free();
	}
}
